unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, OleCtrls, ACTIVEVOICEPROJECTLib_TLB, ExtCtrls,
  ComObj, ActiveX, speech, ComCtrls;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Panel1: TPanel;
    Edit1: TEdit;
    DirectSS1: TDirectSS;
    ComboBox1: TComboBox;
    TrackBar1: TTrackBar;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private declarations }
    FITTSEnum:ITTSEnum;
    FITTSCentral:ITTSCentral;
    FIAMD:IAudioMultimediaDevice;
    PModeInfo:PTTSModeInfo;
    FTTSBufNotifySink:ITTSBufNotifySink;
    FITTSAttributes:ITTSAttributes;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BitBtn1Click(Sender: TObject);
var
 SData : TSData;
begin
 FITTSCentral.Inject(PChar('\Pit=' + IntToStr(TrackBar1.Position) + '\'));
 SData.dwSize := Length(Edit1.Text) + 1;
 SData.pData := PChar(Edit1.Text);
 FITTSCentral.TextData (CHARSET_TEXT, 0,
     SData, Pointer(FTTSBufNotifySink), IID_ITTSBufNotifySink);
// DirectSS1.Speak(Edit1.Text);
end;

procedure TForm1.FormShow(Sender: TObject);
var ModeInfo: TTSModeInfo;
    EngineCount: Integer;
begin
 CoCreateInstance(CLSID_TTSEnumerator, Nil, CLSCTX_ALL, IID_ITTSEnum, FITTSEnum);
 FITTSEnum.Reset;
 FITTSEnum.Next(1, ModeInfo, @EngineCount);

 while EngineCount > 0 do
  begin
   ComboBox1.Items.Add(String(ModeInfo.szModeName));
   FITTSEnum.Next(1, ModeInfo, @EngineCount);
  end;
 TrackBar1.Max:=DirectSS1.MaxPitch;
 TrackBar1.Min:=DirectSS1.MinPitch;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var Index, EngineCount: Integer;
    ModeInfo: TTSModeInfo;
begin
 if ComboBox1.Text='' then exit;

 CoCreateInstance(CLSID_MMAudioDest, nil, CLSCTX_ALL, IID_IAudioMultiMediaDevice, FIAMD);
 Index := ComboBox1.Items.IndexOf(ComboBox1.Text);

 try
  FITTSEnum.Reset;
  FITTSEnum.Skip(Index);
  FITTSEnum.Next(1, ModeInfo, @EngineCount);

  if Assigned(PModeInfo) then Dispose(PModeInfo);
   New(PModeInfo);
  PModeInfo^ := ModeInfo;

  FITTSEnum.Select(PModeInfo^.gModeID, FITTSCentral, FIAMD);
  FITTSCentral.QueryInterface(IID_ITTSAttributes, FITTSAttributes);
except
 end;
end;

end.
